@echo off

set HW_FILE=%2.EXT_FW.%1
set FW_PATH=.
set FW_PROJECT_PATH=Source_%1
set FW_FILE=eEverAMA
set FW_VERSION=%FW_PATH%\%FW_PROJECT_PATH%\eEverAMA.ver
set OUTPUT_FILE=TITAN_ROM_FILE_%1
set HW_FW_LENGTH=0x2000
set DMA_ROM_ADDR_BASE=0xC000
set GEN_HW_FILE=02.gen_hw_set_ext_fw

set FW_ENCODE_TOOL=P2pdRomEncode_v5.0.4.0
set FW_PROGRAM_TOOL=P2pdRomProgram-DLL_v5.0.4.0

if %3 EQU SPI (
	echo === SPI Mode
	set HW_FW_LENGTH=0x8000
	set DMA_ROM_ADDR_BASE=0x0000
) else (
	echo === MTP Mode
)

if exist %FW_PATH%\%FW_PROJECT_PATH%\Object\%FW_FILE%.hex (

	echo === Gen HW setting
	cd TITAN_HW_SET_GEN_00_00_05_02
	call %GEN_HW_FILE%.bat %1
	copy %HW_FILE%.bin ..
	cd ..

	echo === Encode Firmware
	copy %FW_PATH%\%FW_PROJECT_PATH%\Object\%FW_FILE%.hex .
	%FW_ENCODE_TOOL%.exe %HW_FILE%.bin %FW_FILE%.hex %HW_FW_LENGTH% %DMA_ROM_ADDR_BASE%
	del %FW_FILE%.hex
	del %HW_FILE%.bin
	del %FW_FILE%.bin

	echo === Make bin file
	%FW_PROGRAM_TOOL%.exe M %HW_FW_LENGTH% %HW_FILE%_%FW_FILE%.bin
	del %HW_FILE%_%FW_FILE%.bin

	setlocal EnableDelayedExpansion

	call :GetVersion OUTPUT_FILE !FW_VERSION!

	copy TITAN_ROM_FILE.bin !OUTPUT_FILE!.bin
	del  TITAN_ROM_FILE.bin

	echo:
	echo Succeed to generate !OUTPUT_FILE! binary file.
	echo:

	endlocal
) else (
	echo Can not find %FW_FILE%.hex!!
)

goto :EOF


:GetVersion
set TmpName=!%~1!
set VerString=%~2

for /f "Tokens=3 Delims= " %%i in (!VerString!) do set TmpName=!TmpName!.%%i

set find=.
set replace=_
call set TmpName=%%TmpName:!find!=!replace!%%

set %~1=!TmpName!

goto :EOF
